//: C02:BuggedSearch.cpp {-xo}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
//{L} ../TestSuite/Test
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <fstream>
#include "../TestSuite/Test.h"
using namespace std;

// Tato funkce je jedin, ve kter jsou chyby
int* binarniHledani(int* odkud, int* konec, int cosi) {
  while(konec - odkud != 1) {
    if(*odkud == cosi) return odkud;
    int stred = (konec - odkud) / 2;
    if(cosi <= odkud[stred]) konec = odkud + stred;
    else odkud = odkud + stred;
  }
  return 0;
}

class TestBinarnihoHledani : public TestSuite::Test {
  enum { SZ = 10 };
  int* data;
  int max; // Uchovv nejvt slo
  int aktualni; // Aktuln neobsaen slo
               // pouito v neniObsazeno()
  // najt dal slo, kter nen v poli obsaeno 
  int neniObsazeno() {
    while(data[aktualni] + 1 == data[aktualni + 1])
      ++aktualni;
    if(aktualni >= SZ) return max + 1;
    int vysledek = data[aktualni++] + 1;
    return vysledek;
  }
  void setData() {
    data = new int[SZ];
    assert(!max);
    // Po jedn vloit hodnoty. Nechte njak 
		//hodnoty jak na sudch, tak na lichch indexech.
    for(int i = 0; i < SZ;
        rand() % 2 == 0 ? max += 1 : max += 2)
      data[i++] = max;
  }
  void testVRozsahu() {
    // Otestovat jak sud tak lich pozice
    // jestli obsahuj nebo neobsahuj
    for(int i = SZ; --i >=0;)
      test_(binarniHledani(data, data + SZ, data[i]));
    for(int i = neniObsazeno(); i < max;
        i = neniObsazeno())
      test_(!binarniHledani(data, data + SZ, i));
  }
  void testMimoRozsah() {
    // Otestovat ni hodnoty
    for(int i = data[0]; --i > data[0] - 100;)
      test_(!binarniHledani(data, data + SZ, i));
    // Otestovat vy hodnoty
    for(int i = data[SZ - 1];
        ++i < data[SZ -1] + 100;)
      test_(!binarniHledani(data, data + SZ, i));
  }
public:
  TestBinarnihoHledani() { max = aktualni = 0; }
  void run() {
    setData();
    testVRozsahu();
    testMimoRozsah();
    delete [] data;
  }
};

int main() {
  srand(time(0));
  TestBinarnihoHledani t;
  t.run();
  return t.report();
} ///:~
