//: C02:Rational.h {-xo}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
#ifndef RATIONAL_H
#define RATIONAL_H
#include <iosfwd>

class Zlomek {
public:
  Zlomek(int citatel = 0, int jmenovatel = 1);
  Zlomek operator-() const;
  friend Zlomek operator+(const Zlomek&,
                            const Zlomek&);
  friend Zlomek operator-(const Zlomek&,
                            const Zlomek&);
  friend Zlomek operator*(const Zlomek&,
                            const Zlomek&);
  friend Zlomek operator/(const Zlomek&,
                            const Zlomek&);
  friend std::ostream&
  operator<<(std::ostream&, const Zlomek&);
  friend std::istream&
  operator>>(std::istream&, Zlomek&);
  Zlomek& operator+=(const Zlomek&);
  Zlomek& operator-=(const Zlomek&);
  Zlomek& operator*=(const Zlomek&);
  Zlomek& operator/=(const Zlomek&);
  friend bool operator<(const Zlomek&,
                        const Zlomek&);
  friend bool operator>(const Zlomek&,
                        const Zlomek&);
  friend bool operator<=(const Zlomek&,
                         const Zlomek&);
  friend bool operator>=(const Zlomek&,
                         const Zlomek&);
  friend bool operator==(const Zlomek&,
                         const Zlomek&);
  friend bool operator!=(const Zlomek&,
                         const Zlomek&);
};
#endif // RATIONAL_H ///:~
