//: C03:ExtractCode.cpp {-edg} {RunByHand}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Vylenit kd z textu.
#include <cassert>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <iostream>
#include <string>
using namespace std;

// Zddn nestandardn halvikov soubory C kvli mkdir()
#if defined(__GNUC__) || defined(__MWERKS__)
#include <sys/stat.h>
#elif defined(__BORLANDC__) || defined(_MSC_VER) \
  || defined(__DMC__)
#include <direct.h>
#else
#error Peklada nen podporovn
#endif

// Zjistit, zda adres existuje 
// tm, e e v nm pokusme vytvoit
// nov vstupn soubor.
bool exists(string fname) {
  size_t len = fname.length();
  if(fname[len-1] != '/' && fname[len-1] != '\\')
    fname.append("/");
  fname.append("000.tmp");
  ofstream outf(fname.c_str());
  bool existFlag = outf;
  if(outf) {
    outf.close();
    remove(fname.c_str());
  }
  return existFlag;
}

int main(int argc, char* argv[]) {
  // Zjistit, zda je k dispozici nzev vstupnho souboru
  if(argc == 1) {
    cerr << "Pouit: extractCode soubor [adr]" << endl;
    exit(EXIT_FAILURE);
  }
  // Zjistit, zda soubor existuje
  ifstream inf(argv[1]);
  if(!inf) {
    cerr << "chyba pi otevrn souboru: " << argv[1] << endl;
    exit(EXIT_FAILURE);
  }
  // Zjistit vstupn adres
  string root("./");  // aktuln je vchoz
  if(argc == 3) {
    // Zjistit, zda existuje vstupn adres
    root = argv[2];
    if(!exists(root)) {
      cerr << "Takov adres neexistuje: " << root << endl;
      exit(EXIT_FAILURE);
    }
    size_t rootLen = root.length();
    if(root[rootLen-1] != '/' && root[rootLen-1] != '\\')
      root.append("/");
  }
  // st vstupn soubor po dcch 
	// a kontrolovat oddlovae kdu
  string line;
  bool inCode = false;
  bool printDelims = true;
  ofstream outf;
  while(getline(inf, line)) {
    size_t findDelim = line.find("//" "/:~");
    if(findDelim != string::npos) {
      // Vydat posledn dek a zavt soubor
      if(!inCode) {
        cerr << "patn dky" << endl;
        exit(EXIT_FAILURE);
      }
      assert(outf);
      if(printDelims)
        outf << line << endl;
      outf.close();
      inCode = false;
      printDelims = true;
    } else {
      findDelim = line.find("//" ":");
      if(findDelim == 0) {
        // Zkontrolovat direktivu '!'
        if(line[3] == '!') {
          printDelims = false;
          ++findDelim;  // Pro dal hledn peskoit '!'
        }
        // zjistit nzev podadrese, pokud je k dispozici
        size_t startOfSubdir =
          line.find_first_not_of(" \t", findDelim+3);
        findDelim = line.find(':', startOfSubdir);
        if(findDelim == string::npos) {
          cerr << "chyb jmno souboru\n" << endl;
          exit(EXIT_FAILURE);
        }
        string subdir;
        if(findDelim > startOfSubdir)
          subdir = line.substr(startOfSubdir,
                               findDelim - startOfSubdir);
        // Zjistit jmno souboru (mlo by bt jedno!)
        size_t startOfFile = findDelim + 1;
        size_t endOfFile =
          line.find_first_of(" \t", startOfFile);
        if(endOfFile == startOfFile) {
          cerr << "chyb jmno souboru" << endl;
          exit(EXIT_FAILURE);
        }
        // Mme vechny sti; sestavit nzev cel cesty
        string fullPath(root);
        if(subdir.length() > 0)
          fullPath.append(subdir).append("/");
        assert(fullPath[fullPath.length()-1] == '/');
        if(!exists(fullPath))
#if defined(__GNUC__) || defined(__MWERKS__)
          mkdir(fullPath.c_str(), 0);  // Vytvoit podadres
#else
          mkdir(fullPath.c_str());  // Create subdir
#endif
        fullPath.append(line.substr(startOfFile,
                        endOfFile - startOfFile));
        outf.open(fullPath.c_str());
        if(!outf) {
          cerr << "chyba pi oteven " << fullPath
               << " pro vstup" << endl;
          exit(EXIT_FAILURE);
        }
        inCode = true;
        cout << "Zpracovvn " << fullPath << endl;
        if(printDelims)
          outf << line << endl;
      }
      else if(inCode) {
        assert(outf);
        outf << line << endl;  // vydat stedn dek kdu
      }
    }
  }
  exit(EXIT_SUCCESS);
} ///:~
