//: C03:HTMLStripper.cpp {RunByHand}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
//{L} ReplaceAll
// Filtr k odstrann html tag a znaek.
#include <cassert>
#include <cmath>
#include <cstddef>
#include <fstream>
#include <iostream>
#include <string>
#include "ReplaceAll.h"
#include "../require.h"
using namespace std;

string& stripHTMLTags(string& s) {
  static bool vTagu = false;
  bool hotovo = false;
  while(!hotovo) {
    if(vTagu) {
    	// Pedchoz dka zaala HTML tag, 
			// ale neskonila. Musme hledat '>'.
      size_t pravaPozice = s.find('>');
      if(pravaPozice != string::npos) {
        vTagu = false;
        s.erase(0, pravaPozice + 1);
      }
      else {
        hotovo = true;
        s.erase();
      }
    }
    else {
      // Najt zatek tagu
      size_t levaPozice = s.find('<');
      if(levaPozice != string::npos) {
        // Zjistit, zda je tag na tomto dku ukonen:
        size_t pravaPozice = s.find('>');
        if(pravaPozice == string::npos) {
          vTagu = hotovo = true;
          s.erase(levaPozice);
        }
        else
          s.erase(levaPozice, pravaPozice - levaPozice + 1);
      }
      else
        hotovo = true;
    }
  }
  // Odstranit vechny zvltn HTML znaky
  nahraditVse(s, "&lt;", "<");
  nahraditVse(s, "&gt;", ">");
  nahraditVse(s, "&amp;", "&");
  nahraditVse(s, "&nbsp;", " ");
  // Atd...
  return s;
}

int main(int argc, char* argv[]) {
  requireArgs(argc, 1,
    "Pouit: HTMLStripper VstupniSoubor");
  ifstream in(argv[1]);
  assure(in, argv[1]);
  string s;
  while(getline(in, s))
    if(!stripHTMLTags(s).empty())
      cout << s << endl;
} ///:~
