//: C03:Rparse.h
// From "Thinking in C++, Volume 2", by Bruce Eckel & Chuck Allison.
// (c) 1995-2004 MindView, Inc. All Rights Reserved.
// See source code use permissions stated in the file 'License.txt',
// distributed with the code package available at www.MindView.net.
#ifndef RPARSE_H
#define RPARSE_H
#include <cstddef>
#include <string>
#include <vector>
#include "../TestSuite/Test.h"
using std::size_t;
using std::string;
using std::vector;

class RparseTest : public TestSuite::Test {
  // To store the words:
  vector<string> strings;
public:
  void parseData() {
    // Znak ';' bude oddlova
    string s("smysl.;prav;dvat;konen;bude;to;Te");
    // Posledn prvek etzce:
    int posledni = s.size();
    // Zatek aktulnho slova:
    size_t aktualni = s.rfind(';');
    // pozptku prochzet etzec:
    while(aktualni != string::npos) {
      // Kad slovo vloit do vektoru.
      // Aktualni se inkremntuje pedem, 
			// aby se zabrnilo koprovn oddlovae
      ++aktualni;
      strings.push_back(s.substr(aktualni, posledni - aktualni));
      // Zpt pes prv nalezen oddlova
      // a nastavit posledni na konec dalho slova
      aktualni -= 2;
      posledni = aktualni + 1;
      // Najt dal oddlova:
      aktualni = s.rfind(';', aktualni);
    }
    // Najt prvn slovo -- nen ped nm odlova:
    strings.push_back(s.substr(0, posledni));
  }
  void testData() {
    // Otestovat je v novm poad:
    test_(strings[0] == "Te");
    test_(strings[1] == "to");
    test_(strings[2] == "bude");
    test_(strings[3] == "konen");
    test_(strings[4] == "dvat");
    test_(strings[5] == "prav");
    test_(strings[6] == "smysl.");
    string veta;
    for(size_t i = 0; i < strings.size() - 1; i++)
      veta += strings[i] += " ";
    // Run vloit posledn slovo aby se zabrnilo mezerm navc:
    veta += strings[strings.size() - 1];
    test_(veta == "Te to bude konen dvat prav smysl.");
  }
  void run() {
    parseData();
    testData();
  }
};
#endif // RPARSE_H ///:~
