//: C03:Sieve.h
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
#ifndef SIEVE_H
#define SIEVE_H
#include <cmath>
#include <cstddef>
#include <string>
#include "../TestSuite/Test.h"
using std::size_t;
using std::sqrt;
using std::string;

class TestSita : public TestSuite::Test {
  string znakySita;
public:
  // Vytvoit 50 znakov etzec a nastavit 
	// kad prvek na 'P' jako prvoslo:
  TestSita() : znakySita(50, 'P') {}
  void run() {
    najdiPrvocisla();
    testPrvocisel();
  }
  bool jePrvocislo(int p) {
    if(p == 0 || p == 1) return false;
    int koren = int(sqrt(double(p)));
    for(int i = 2; i <= koren; ++i)
      if(p % i == 0) return false;
    return true;
  }
  void najdiPrvocisla() {
    // Podle definice nen prvoslo ani 0 ani 1. 
    // Zmenit tyto prvky na 'N' jako nen prvoslo:
    znakySita.replace(0, 2, "NN");
    // Projt pole:
    size_t velikostSita = znakySita.size();
    int koren = int(sqrt(double(velikostSita)));
    for(int i = 2; i <= koren; ++i)
      // Najt vechny nsobky:
      for(size_t nasobek = 2; nasobek * i < velikostSita;
           ++nasobek)
        znakySita[nasobek * i] = 'N';
  }
  void testPrvocisel() {
    size_t i = znakySita.find('P');
    while(i != string::npos) {
      test_(jePrvocislo(i++));
      i = znakySita.find('P', i);
    }
    i = znakySita.find_first_not_of('P');
    while(i != string::npos) {
      test_(!jePrvocislo(i++));
      i = znakySita.find_first_not_of('P', i);
    }
  }
};
#endif // SIEVE_H ///:~
