//: C04:DataLogger.h
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Datalogger record layout.
#ifndef DATALOG_H
#define DATALOG_H
#include <ctime>
#include <iosfwd>
#include <string>
using std::ostream;

struct Souradnice {
  int stupne, min, sec;
  Souradnice(int d = 0, int m = 0, int s = 0)
  : stupne(d), min(m), sec(s) {}
  std::string toString() const;
};

ostream& operator<<(ostream&, const Souradnice&);

class MerenyBod {
  std::time_t timestamp; // as & den
  Souradnice sirka, delka;
  double hloubka, teplota;
public:
  MerenyBod(std::time_t ts, const Souradnice& sir,
            const Souradnice& del, double hl, double tep)
  : timestamp(ts), sirka(sir), delka(del),
      hloubka(hl), teplota(tep) {}
  MerenyBod() : timestamp(0), hloubka(0), teplota(0) {}
  friend ostream& operator<<(ostream&, const MerenyBod&);
};
#endif // DATALOG_H ///:~
