//: C04:Showerr.cpp {RunByHand}
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Odkomentovv genertory chyb.
#include <cstddef>
#include <cstdlib>
#include <cstdio>
#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include "../require.h"
using namespace std;

const string USAGE =
  "Pouit: showerr soubor cislokap\n"
  "kde soubor je zdrojov soubor C++ \n"
  "a cislokap je nzev kapitoly, do kter pat.\n"
  "Najde dky s komentem //! a odstran jej,\n"
  "a pipoj //(#) kde # je slo jedinen\n"
  "pro vechny soubory, take je mete rozpoznat\n"
  "kdy peklada naraz na chybu.\n"
  "showerr /r\n"
  "Nuluje ta jedinench sel.";

class Showerr {
  const int CHAP;
  const string MARKER, FNAME;
  // Soubor obsahujc ta sel chyb:
  const string ERRNUM;
  // Soubor obsahujc chybov dky:
  const string ERRFILE;
  stringstream edited; // Upravovan soubor
  int counter;
public:
  Showerr(const string& f, const string& en,
    const string& ef, int c)
  : CHAP(c), MARKER("//!"), FNAME(f), ERRNUM(en),
    ERRFILE(ef), counter(0) {}
  void replaceErrors() {
    ifstream infile(FNAME.c_str());
    assure(infile, FNAME.c_str());
    ifstream count(ERRNUM.c_str());
    if(count) count >> counter;
    int linecount = 1;
    string buf;
    ofstream errlines(ERRFILE.c_str(), ios::app);
    assure(errlines, ERRFILE.c_str());
    while(getline(infile, buf)) {
      // Najt znaku na zatku dku:
      size_t pos = buf.find(MARKER);
      if(pos != string::npos) {
        // Smazat dku:
        buf.erase(pos, MARKER.size() + 1);
        // Pidat informaci o sle chyby:
        ostringstream out;
        out << buf << " // (" << ++counter << ") "
            << "Kapitola " << CHAP
            << " Soubor: " << FNAME
            << " dek " << linecount << endl;
        edited << out.str();
        errlines << out.str(); // Pipojit soubor s chybami
      }
      else
        edited << buf << "\n"; // Pouze zkoprovat
      ++linecount;
    }
  }
  void saveFiles() {
    ofstream outfile(FNAME.c_str()); // pepisuje
    assure(outfile, FNAME.c_str());
    outfile << edited.rdbuf();
    ofstream count(ERRNUM.c_str()); // pepisuje
    assure(count, ERRNUM.c_str());
    count << counter; // Uloit nov ta
  }
};

int main(int argc, char* argv[]) {
  const string ERRCOUNT("../errnum.txt"),
    ERRFILE("../errlines.txt");
  requireMinArgs(argc, 1, USAGE.c_str());
  if(argv[1][0] == '/' || argv[1][0] == '-') {
    // Umonit dal pepnae:
    switch(argv[1][1]) {
      case 'r': case 'R':
        cout << "Nuluji ta" << endl;
        remove(ERRCOUNT.c_str()); // Smazat soubory
        remove(ERRFILE.c_str());
        return EXIT_SUCCESS;
      default:
        cerr << USAGE << endl;
        return EXIT_FAILURE;
    }
  }
  if(argc == 3) {
    Showerr s(argv[1], ERRCOUNT, ERRFILE, atoi(argv[2]));
    s.replaceErrors();
    s.saveFiles();
  }
} ///:~
