//: C06:MemFun1.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Pouit ukazatel na lensk funkce.
#include <algorithm>
#include <functional>
#include <iostream>
#include <vector>
#include "../purge.h"
using namespace std;

class Tvar {
public:
  virtual void vykreslit() = 0;
  virtual ~Tvar() {}
};

class Kruh : public Tvar {
public:
  virtual void vykreslit() { cout << "Kruh::vykreslit()" << endl; }
  ~Kruh() { cout << "Kruh::~Kruh()" << endl; }
};

class Ctverec : public Tvar {
public:
  virtual void vykreslit() { cout << "Ctverec::vykreslit()" << endl; }
  ~Ctverec() { cout << "Ctverec::~Ctverec()" << endl; }
};

int main() {
  vector<Tvar*> vs;
  vs.push_back(new Kruh);
  vs.push_back(new Ctverec);
  for_each(vs.begin(), vs.end(), mem_fun(&Tvar::vykreslit));
  purge(vs);
} ///:~
