//: C06:NString.h
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// slovan etzec, kter uchovv zznam 
// o potu vskyt slova, kter obsahuje.
#ifndef NSTRING_H
#define NSTRING_H
#include <algorithm>
#include <iostream>
#include <string>
#include <utility>
#include <vector>

typedef std::pair<std::string, int> psi;

// Pouze porovn prvn prvek
bool operator==(const psi& l, const psi& r) {
  return l.first == r.first;
}

class NString {
  std::string s;
  int tentoVyskyt;
  // Uchovv zznam o potu vskyt:
  typedef std::vector<psi> vp;
  typedef vp::iterator vpit;
  static vp slova;
  void pridatRetezec(const std::string& x) {
    psi p(x, 0);
    vpit it = std::find(slova.begin(), slova.end(), p);
    if(it != slova.end())
      tentoVyskyt = ++it->second;
    else {
      tentoVyskyt = 0;
      slova.push_back(p);
    }
  }
public:
  NString() : tentoVyskyt(0) {}
  NString(const std::string& x) : s(x) { pridatRetezec(x); }
  NString(const char* x) : s(x) { pridatRetezec(x); }
  // Implicitn operator= a koprovac konstruktor jsou zde OK.
  friend std::ostream& operator<<(
    std::ostream& os, const NString& ns) {
    return os << ns.s << " [" << ns.tentoVyskyt << "]";
  }
 	// Tohle je poteba pro tdn. Vimnte si, 
	//e se porovnvj jen etzce a ne vskyty:
  friend bool
  operator<(const NString& l, const NString& r) {
    return l.s < r.s;
  }
  friend
  bool operator==(const NString& l, const NString& r) {
    return l.s == r.s;
  }
  // Pro tdn s greater<NString>:
  friend bool
  operator>(const NString& l, const NString& r) {
    return l.s > r.s;
  }
  // k pmmu zskn etzce:
  operator const std::string&() const { return s; }
};

// Protoe NString::vp je ablona a pouvme model vkldn, 
// mus se definovat v hlavikovm souboru:

NString::vp NString::slova;
#endif // NSTRING_H ///:~
