//: C07:MultiSet1.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Ukazuje chovn vcensobn mnoiny.
#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <iterator>
#include <set>
using namespace std;

class X {
  char c; // pouito pi porovnvn
  int i; // nepouito pi porovnvn
  // Nepotebuje standardn konstruktor a operator=
  X();
  X& operator=(const X&);
  // Obvykle je poteba koprovac konstruktor (ale 
	// spojen verze zde funguje)
public:
  X(char cc, int ii) : c(cc), i(ii) {}
  // Vimnte si, e nen poteba operator==
  friend bool operator<(const X& x, const X& y) {
    return x.c < y.c;
  }
  friend ostream& operator<<(ostream& os, X x) {
    return os << x.c << ":" << x.i;
  }
};

class Xgen {
  static int i;
  // Poet znak, ze kterch se vybr:
  enum { SPAN = 6 };
public:
  X operator()() {
    char c = 'A' + rand() % SPAN;
    return X(c, i++);
  }
};

int Xgen::i = 0;

typedef multiset<X> Xmset;
typedef Xmset::const_iterator Xmit;

int main() {
  Xmset mset;
  // Naplnit pomoc X:
  srand(time(0));  // Nhodn sla
  generate_n(inserter(mset, mset.begin()), 25, Xgen());
  // Inicializovat bnou mnoinu z 
	// vcensobn mnoiny
  set<X> unique(mset.begin(), mset.end());
  copy(unique.begin(), unique.end(),
    ostream_iterator<X>(cout, " "));
  cout << "\n----" << endl;
  // Projt jedinen hodnoty:
  for(set<X>::iterator i = unique.begin();
      i != unique.end(); i++) {
    pair<Xmit, Xmit> p = mset.equal_range(*i);
    copy(p.first,p.second, ostream_iterator<X>(cout, " "));
    cout << endl;
  }
} ///:~
