//: C07:PriorityQueue3.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Pokroilej pouit priority_queue.
#include <iostream>
#include <queue>
#include <string>
using namespace std;

class PlanovanyUkol {
  char hlavni;
  int vedlejsi;
  string ukol;
public:
  PlanovanyUkol(string td, char pri = 'A', int sec = 1)
  : hlavni(pri), vedlejsi(sec), ukol(td) {}
  friend bool operator<(
    const PlanovanyUkol& x, const PlanovanyUkol& y) {
    if(x.hlavni > y.hlavni)
      return true;
    if(x.hlavni == y.hlavni)
      if(x.vedlejsi > y.vedlejsi)
        return true;
    return false;
  }
  friend ostream&
  operator<<(ostream& os, const PlanovanyUkol& td) {
    return os << td.hlavni << td.vedlejsi
      << ": " << td.ukol;
  }
};

int main() {
  priority_queue<PlanovanyUkol> seznamUkolu;
  seznamUkolu.push(PlanovanyUkol("Vysypat ko", 'C', 4));
  seznamUkolu.push(PlanovanyUkol("Nakrmit psa", 'A', 2));
  seznamUkolu.push(PlanovanyUkol("Namrmit andulku", 'B', 7));
  seznamUkolu.push(PlanovanyUkol("Posekat trvnk", 'C', 3));
  seznamUkolu.push(PlanovanyUkol("Zalt trvnk", 'A', 1));
  seznamUkolu.push(PlanovanyUkol("Nakrmit koku", 'B', 1));
  while(!seznamUkolu.empty()) {
    cout << seznamUkolu.top() << endl;
    seznamUkolu.pop();
  }
} ///:~
