//: C07:Stack2.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// pevod kontejneru list na stack.
#include <iostream>
#include <fstream>
#include <stack>
#include <list>
#include <string>
#include <cstddef>
using namespace std;

// oekv se stack:
template<class Stk>
void stackOut(Stk& s, ostream& os = cout) {
  while(!s.empty()) {
    os << s.top() << "\n";
    s.pop();
  }
}

class Line {
  string line; // bez vodnch mezer
  size_t lspaces; // poet vodnch mezer
public:
  Line(string s) : line(s) {
    lspaces = line.find_first_not_of(' ');
    if(lspaces == string::npos)
      lspaces = 0;
    line = line.substr(lspaces);
  }
  friend ostream& operator<<(ostream& os, const Line& l) {
    for(size_t i = 0; i < l.lspaces; i++)
      os << ' ';
    return os << l.line;
  }
  // Zde budou dal funkce...
};

int main() {
  ifstream in("Stack2.cpp");
  list<Line> lines;
  // Nast soubor a uloit dky do seznamu
  string s;
  while(getline(in, s))
    lines.push_front(s);
  // Kvli tisku pevst seznam na zsobnk
  stack<Line, list<Line> > stk(lines);
  stackOut(stk);
} ///:~
