//: C09:VirtualBase2.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Jak neimplementovat opertor <<.
#include <iostream>
using namespace std;

class Nejvyssi {
  int x;
public:
  Nejvyssi(int n) { x = n; }
  virtual ~Nejvyssi() {}
  friend ostream& operator<<(ostream& os, const Nejvyssi& t) {
    return os << t.x;
  }
};

class Leva : virtual public Nejvyssi {
  int y;
public:
  Leva(int m, int n) : Nejvyssi(m) { y = n; }
  friend ostream& operator<<(ostream& os, const Leva& l) {
    return os << static_cast<const Nejvyssi&>(l) << ',' << l.y;
  }
};

class Prava : virtual public Nejvyssi {
  int z;
public:
  Prava(int m, int n) : Nejvyssi(m) { z = n; }
  friend ostream& operator<<(ostream& os, const Prava& r) {
    return os << static_cast<const Nejvyssi&>(r) << ',' << r.z;
  }
};

class Nejnizsi : public Leva, public Prava {
  int w;
public:
  Nejnizsi(int i, int j, int k, int m)
  : Nejvyssi(i), Leva(0, j), Prava(0, k) { w = m; }
  friend ostream& operator<<(ostream& os, const Nejnizsi& b){
    return os << static_cast<const Leva&>(b)
      << ',' << static_cast<const Prava&>(b)
      << ',' << b.w;
  }
};

int main() {
  Nejnizsi b(1, 2, 3, 4);
  cout << b << endl;  // 1,2,1,3,4
} ///:~
