//: C10:ChainOfReponsibility.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Pstup ptiltho
#include <iostream>
#include <vector>
#include "../purge.h"
using namespace std;

enum Odpoved { NE, ANO };

class StrategieJaToChci {
public:
  virtual Odpoved mohlBychDostat() = 0;
  virtual ~StrategieJaToChci() {}
};

class ZeptatSeMamky : public StrategieJaToChci {
public:
  Odpoved mohlBychDostat() {
    cout << "Mami? Mohl bych to dostat?" << endl;
    return NE;
  }
};

class ZeptatSeTatky : public StrategieJaToChci {
public:
  Odpoved mohlBychDostat() {
    cout << "Tati, Fakt to potebuju!" << endl;
    return NE;
  }
};

class ZeptatSeDedecka : public StrategieJaToChci {
public:
  Odpoved mohlBychDostat() {
    cout << "Ddo, u mm narozeniny?" << endl;
    return NE;
  }
};

class ZeptatSeBabicky : public StrategieJaToChci {
public:
  Odpoved mohlBychDostat() {
    cout << "Babi, mm t moc rd!" << endl;
    return ANO;
  }
};

class JaToChci : public StrategieJaToChci {
  vector<StrategieJaToChci*> retez;
public:
  JaToChci() {
    retez.push_back(new ZeptatSeMamky());
    retez.push_back(new ZeptatSeTatky());
    retez.push_back(new ZeptatSeDedecka());
    retez.push_back(new ZeptatSeBabicky());
  }
  Odpoved mohlBychDostat() {
    vector<StrategieJaToChci*>::iterator it = retez.begin();
    while(it != retez.end())
      if((*it++)->mohlBychDostat() == ANO)
        return ANO;
    // Dosaeno konce bez spchu...
    cout << "B!" << endl;
    return NE;
  }
  ~JaToChci() { purge(retez); }
};

int main() {
  JaToChci retez;
  retez.mohlBychDostat();
} ///:~
