//: C10:InnerClassIdiom.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Pklad idiomu "vnitn tda".
#include <iostream>
#include <string>
using namespace std;

class Pingnutelna {
public:
  virtual void ping() = 0;
};

void volatPing(Pingnutelna& p) {
  p.ping();
}

class Bingnutelna {
public:
  virtual void bing() = 0;
};

void volatBing(Bingnutelna& b) {
  b.bing();
}

class Vnejsi {
  string nazev;
  // Definovat jednu vnitn tdu:
  class Vnitrni1;
  friend class Vnejsi::Vnitrni1;
  class Vnitrni1 : public Pingnutelna {
    Vnejsi* rodic;
  public:
    Vnitrni1(Vnejsi* p) : rodic(p) {}
    void ping() {
      cout << "ping volno pro "
        << rodic->nazev << endl;
      // Pistup k datm objektu vnj tdy
    }
  } vnitrni1;
  // Definovat druhou vnitn tdu:
  class Vnitrni2;
  friend class Vnejsi::Vnitrni2;
  class Vnitrni2 : public Bingnutelna {
    Vnejsi* rodic;
  public:
    Vnitrni2(Vnejsi* p) : rodic(p) {}
    void bing() {
      cout << "bing volno pro "
        << rodic->nazev << endl;
    }
  } vnitrni2;
public:
  Vnejsi(const string& nm)
  : nazev(nm), vnitrni1(this), vnitrni2(this) {}
  // Vrtit referenci na rozhran 
	//implementovan vnitnmi tdami.
  operator Pingnutelna&() { return vnitrni1; }
  operator Bingnutelna&() { return vnitrni2; }
};

int main() {
  Vnejsi x("Ping Pong");
  // Jako petypovn nahoru na vce bzovch typ!:
  volatPing(x);
  volatBing(x);
} ///:~
