//: C10:Observable.h
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Tda Pozorovatelny.
#ifndef OBSERVABLE_H
#define OBSERVABLE_H
#include <set>
#include "Observer.h"

class Pozorovatelny {
  bool zmeneny;
  std::set<Pozorovatel*> pozorovatele;
protected:
  virtual void nastavitZmeneny() { zmeneny = true; }
  virtual void zrusitZmeneny() { zmeneny = false; }
public:
  virtual void pridatPozorovatele(Pozorovatel& o) {
    pozorovatele.insert(&o);
  }
  virtual void smazatPozorovatele(Pozorovatel& o) {
    pozorovatele.erase(&o);
  }
  virtual void smazatVsechnyPozorovatele() {
    pozorovatele.clear();
  }
  virtual int pocetPozorovatelu() {
    return pozorovatele.size();
  }
  virtual bool zmenilSe() { return zmeneny; }
  //Jestlie se tento objekt zmnil, informovat 
	//o tom vechny jeho pozorovatele:
  virtual void upozornitPozorovatele(Argument* arg = 0) {
    if(!zmenilSe()) return;
    zrusitZmeneny(); // Ji nen zmnn
    std::set<Pozorovatel*>::iterator it;
    for(it = pozorovatele.begin();it != pozorovatele.end(); it++)
      (*it)->aktualizovat(this, arg);
  }
  virtual ~Pozorovatelny() {}
};
#endif // OBSERVABLE_H ///:~
