//: C10:ObservedFlower.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Ukzka vzoru pozorovatel
#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include "Observable.h"
using namespace std;

class Kvetina {
  bool jeOtevrena;
public:
  Kvetina() : jeOtevrena(false),
    otevritHlasic(this), zavritHlasic(this) {}
  void otevrit() { // otevr sv okvtn pltky
    jeOtevrena = true;
    otevritHlasic.upozornitPozorovatele();
    zavritHlasic.otevrit();
  }
  void zavrit() { // zavr sv okvtn pltky
    jeOtevrena = false;
    zavritHlasic.upozornitPozorovatele();
    otevritHlasic.zavrit();
  }
  // pouit idiomu "vnitn tda":
  class OtevritHlasic;
  friend class Kvetina::OtevritHlasic;
  class OtevritHlasic : public Pozorovatelny {
    Kvetina* rodic;
    bool jizOtevrena;
  public:
    OtevritHlasic(Kvetina* f) : rodic(f),
      jizOtevrena(false) {}
    void upozornitPozorovatele(Argument* arg = 0) {
      if(rodic->jeOtevrena && !jizOtevrena) {
        nastavitZmeneny();
        Pozorovatelny::upozornitPozorovatele();
        jizOtevrena = true;
      }
    }
    void zavrit() { jizOtevrena = false; }
  } otevritHlasic;
  class ZavritHlasic;
  friend class Kvetina::ZavritHlasic;
  class ZavritHlasic : public Pozorovatelny {
    Kvetina* rodic;
    bool jizZavrena;
  public:
    ZavritHlasic(Kvetina* f) : rodic(f),
      jizZavrena(false) {}
    void upozornitPozorovatele(Argument* arg = 0) {
      if(!rodic->jeOtevrena && !jizZavrena) {
        nastavitZmeneny();
        Pozorovatelny::upozornitPozorovatele();
        jizZavrena = true;
      }
    }
    void otevrit() { jizZavrena = false; }
  } zavritHlasic;
};

class Vcela {
  string nazev;
  // Vnitn tda pro sledovn oteven
  class OtevritPozorovatele;
  friend class Vcela::OtevritPozorovatele;
  class OtevritPozorovatele : public Pozorovatel {
    Vcela* rodic;
  public:
    OtevritPozorovatele(Vcela* b) : rodic(b) {}
    void aktualizovat(Pozorovatelny*, Argument *) {
      cout << "Je as na sndani pro velu " << rodic->nazev
        << endl;
    }
  } otevritPoz;
  // Jin "vnitn tda" pro zavrn
  class ZavritPozorovatele;
  friend class Vcela::ZavritPozorovatele;
  class ZavritPozorovatele : public Pozorovatel {
    Vcela* rodic;
  public:
    ZavritPozorovatele(Vcela* b) : rodic(b) {}
    void aktualizovat(Pozorovatelny*, Argument *) {
      cout << "Vela " << rodic->nazev
        << " by mla jt spt!" << endl;
    }
  } zavritPoz;
public:
  Vcela(string nm) : nazev(nm),
    otevritPoz(this), zavritPoz(this) {}
  Pozorovatel& otevritPozorovatele() { return otevritPoz; }
  Pozorovatel& zavritPozorovatele() { return zavritPoz;}
};

class Kolibrik {
  string nazev;
  class OtevritPozorovatele;
  friend class Kolibrik::OtevritPozorovatele;
  class OtevritPozorovatele : public Pozorovatel {
    Kolibrik* rodic;
  public:
    OtevritPozorovatele(Kolibrik* k) : rodic(k) {}
    void aktualizovat(Pozorovatelny*, Argument *) {
      cout << "Je as na sndani pro Kolibka " << rodic->nazev
        << endl;
    }
  } otevritPoz;
  class ZavritPozorovatele;
  friend class Kolibrik::ZavritPozorovatele;
  class ZavritPozorovatele : public Pozorovatel {
    Kolibrik* rodic;
  public:
    ZavritPozorovatele(Kolibrik* k) : rodic(k) {}
    void aktualizovat(Pozorovatelny*, Argument *) {
      cout << "Kolibk " << rodic->nazev
        << " by ml jt spt!" << endl;
    }
  } zavritPoz;
public:
  Kolibrik(string nm) : nazev(nm),
    otevritPoz(this), zavritPoz(this) {}
  Pozorovatel& otevritPozorovatele() { return otevritPoz; }
  Pozorovatel& zavritPozorovatele() { return zavritPoz;}
};

int main() {
  Kvetina f;
  Vcela va("A"), vb("B");
  Kolibrik ka("A"), kb("B");
  f.otevritHlasic.pridatPozorovatele(ka.otevritPozorovatele());
  f.otevritHlasic.pridatPozorovatele(kb.otevritPozorovatele());
  f.otevritHlasic.pridatPozorovatele(va.otevritPozorovatele());
  f.otevritHlasic.pridatPozorovatele(vb.otevritPozorovatele());
  f.zavritHlasic.pridatPozorovatele(ka.zavritPozorovatele());
  f.zavritHlasic.pridatPozorovatele(kb.zavritPozorovatele());
  f.zavritHlasic.pridatPozorovatele(va.zavritPozorovatele());
  f.zavritHlasic.pridatPozorovatele(vb.zavritPozorovatele());
  // Kolibk B se rozhodl spt uvnit:
  f.otevritHlasic.smazatPozorovatele(kb.otevritPozorovatele());
  // zmnilo se nco, co pozorovatele zajm:
  f.otevrit();
  f.otevrit(); // Je ji otevena; dn zmna.
  // Vcela A nechce jt spt:
  f.zavritHlasic.smazatPozorovatele(
    va.zavritPozorovatele());
  f.zavrit();
  f.zavrit(); // Je ji zaven; dn zmna.
  f.otevritHlasic.smazatVsechnyPozorovatele();
  f.otevrit();
  f.zavrit();
} ///:~
