//: C10:Strategy.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Nvrhov vzor Strategie
#include <iostream>
using namespace std;

class StrategieJmeno {
public:
  virtual void pozdravit() = 0;
};

class Pozdravit : public StrategieJmeno {
public:
  void pozdravit() {
    cout << "Ahoj! Jak se m?" << endl;
  }
};

class Ignorovat : public StrategieJmeno {
public:
  void pozdravit() {
    cout << "(Dlm, e t nevidm)" << endl;
  }
};

class PriznatSe : public StrategieJmeno {
public:
  void pozdravit() {
    cout << "Promi. Zapomnl jsem, jak se jmenuje." << endl;
  }
};

// "Kontext" d strategii:
class Kontext {
  StrategieJmeno& strategie;
public:
  Kontext(StrategieJmeno& strat) : strategie(strat) {}
  void pozdravit() { strategie.pozdravit(); }
};

int main() {
  Pozdravit pozdravit;
  Ignorovat ignorovat;
  PriznatSe priznani;
  Kontext c1(pozdravit), c2(ignorovat), c3(priznani);
  c1.pozdravit();
  c2.pozdravit();
  c3.pozdravit();
} ///:~
