//: C11:ReferenceCounting.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// ablona CountedPtr zabrauje pedasnmu zruen.
//{L} ZThread
#include <iostream>
#include "zthread/Thread.h"
#include "zthread/CountedPtr.h"
using namespace ZThread;
using namespace std;

class Pocet {
  enum { SZ = 100 };
  int n[SZ];
public:
  void inkrementovat() {
    for(int i = 0; i < SZ; i++)
      n[i]++;
  }
};

class Prirustky : public Runnable {
  CountedPtr<Pocet> pocet;
public:
  Prirustky(const CountedPtr<Pocet>& c ) : pocet(c) {}
  void run() {
    for(int n = 100; n > 0; n--) {
      Thread::sleep(250);
      pocet->inkrementovat();
    }
  }
};

int main() {
  CountedPtr<Pocet> pocet(new Pocet);
  try {
    Thread t0(new Prirustky(pocet));
    Thread t1(new Prirustky(pocet));
  } catch(Synchronization_Exception& e) {
    cerr << e.what() << endl;
  }
} ///:~
