//: C11:TemporaryUnlocking.cpp
// Z knihy "Myslme v jazyce C++, st 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Vechna prva vyhrazena.
// Pette si podmnky pouvn zdrojovch kd umstn v souboru 
// 'Licence.txt' dodvanm spolu s balkem kdu dostupnm na www.MindView.net.
// Doasn odemen jinho strce.
//{L} ZThread
#include "zthread/Thread.h"
#include "zthread/Mutex.h"
#include "zthread/Guard.h"
using namespace ZThread;

class TemporaryUnlocking {
  Mutex lock;
public:
  void f() {
    Guard<Mutex> g(lock);
    // zmek je uzamen
    // ...
    {
      Guard<Mutex, UnlockedScope> h(g);
      // zmek je uvolnn
      // ...
      // zmek je uzamen
    }
    // ...
    // zmek je uvolnn
  }
};

int main() {
  TemporaryUnlocking t;
  t.f();
} ///:~
